<script setup lang="ts">
import { onMounted, reactive } from 'vue'
import API from '@/scripts/api'
import { useAppStore } from '@/store/app'
import { VotingRightOverride } from '@/scripts/types'

const app = useAppStore()
const state = reactive({
  loading: true,
  overrides: [] as VotingRightOverride[]
})

const newOverrideModalState = reactive({
  displayed: false,
  sciper: '',
  description: ''
})

const headers = [
  {
    title: 'Sciper',
    align: 'center',
    key: 'sciper'
  },
  {
    title: 'Nom complet',
    align: 'start',
    key: 'display_name'
  },
  {
    title: 'Description',
    align: 'center',
    key: 'description'
  },
  {
    title: 'Action',
    align: 'right',
    key: 'actions'
  }
]

onMounted(() => {
  refresh()
})

function refresh() {
  state.loading = true
  API.getVotingRightOverrides().then(overrides => {
    state.overrides = overrides
  }).catch(err => {
    console.error('Unable to get voting right overrides', err)
  }).finally(() => {
    state.loading = false
  })
}

function modalAddOverride() {
  if (newOverrideModalState.sciper.length !== 6) return

  API.updateVotingRightOverride(newOverrideModalState.sciper, true, newOverrideModalState.description ?? null).then(() => {
    app.notification('info', `Override pour ${newOverrideModalState.sciper} ajouté !`)
    refresh()
    newOverrideModalState.displayed = false
  }).catch(err => {
    app.notification('error', 'Erreur lors de l\'ajout de l\'override')
    console.error('override add error : ', err)
  })
}

function deleteOverride(sciper: string) {
  API.updateVotingRightOverride(sciper, false, null).then(() => {
    app.notification('info', `Override pour ${sciper} supprimé !`)
    refresh()
  }).catch(err => {
    app.notification('error', 'Erreur lors de la suppression de l\'override')
    console.error('override delete error : ', err)
  })
}

</script>

<template>
  <div class="px-5">
    <div class="flex flex-col sm:flex-row items-center">
      <h2 class="text-xl">Liste des override de droit de vote</h2>
    </div>
    <div class="flex flex-col sm:flex-row items-center mt-3">
      <div class="flex flex-col sm:flex-row mt-2 sm:mt-0">
        <v-btn class="mb-4 sm:mb-0 sm:mx-2" color="primary" variant="tonal" size="small" @click="refresh" :loading="state.loading">Actualiser</v-btn>
        <v-btn class="mb-4 sm:mb-0 sm:mx-2" color="warning" variant="tonal" size="small" @click="() => newOverrideModalState.displayed = true">Nouveau</v-btn>
      </div>
    </div>

    <v-dialog v-model="newOverrideModalState.displayed" max-width="500px">
      <v-card>
        <v-card-title>
          <span class="text-h5">Ajout d'un override</span>
        </v-card-title>

        <v-card-text>
          <v-text-field placeholder="N° SCIPER" v-model="newOverrideModalState.sciper"/>
          <v-text-field placeholder="Description ?" v-model="newOverrideModalState.description"/>
        </v-card-text>

        <v-card-actions>
          <div class="flex-grow" />
          <v-btn variant="text" @click="() => newOverrideModalState.displayed = false">
            Annuler
          </v-btn>
          <v-btn color="success" variant="text" @click="modalAddOverride" :disabled="newOverrideModalState.sciper.length !== 6">
            Executer
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-data-table :headers="headers" :items="state.overrides" :sort-by="[{ key: 'sciper', order: 'asc' }]" class="elevation-1 mt-3" :loading="state.loading">

      <!--eslint-disable-next-line vue/valid-v-slot -->
      <template v-slot:item.actions="{ item }">
        <v-btn class="mb-4 sm:mb-0 sm:mx-2" color="warning" variant="outlined" size="small" @click="() => deleteOverride(item.raw.sciper)">Supprimer</v-btn>
      </template>

    </v-data-table>
  </div>
</template>
